"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebpackEslintPlugin = void 0;
const eslint_webpack_plugin_1 = __importDefault(require("eslint-webpack-plugin"));
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const core_1 = require("@zero-scripts/core");
const webpack_config_1 = require("@zero-scripts/webpack-config");
const getBaseEslintConfig_1 = require("./getBaseEslintConfig");
const getEslintConfigPath_1 = require("./getEslintConfigPath");
const WebpackEslintPluginOptions_1 = require("./WebpackEslintPluginOptions");
let WebpackEslintPlugin = class WebpackEslintPlugin extends core_1.AbstractPlugin {
    apply(applyContext) {
        applyContext.hooks.beforeRun.tap('WebpackEslintPlugin', beforeRunContext => {
            const config = beforeRunContext.getConfigBuilder(webpack_config_1.WebpackConfig);
            config.hooks.build.tap('WebpackEslintPlugin', (modifications, configOptions) => {
                const { jsFileExtensions, paths } = configOptions;
                const pluginOptions = this.optionsContainer.build();
                if (pluginOptions.syncConfig.enabled) {
                    const eslintRcConfig = getEslintConfigPath_1.getEslintConfigPath(paths.root);
                    if (!eslintRcConfig) {
                        const baseEslintConfig = getBaseEslintConfig_1.getBaseEslintConfig(configOptions, pluginOptions.baseEslintConfig);
                        const eslintConfigPath = path_1.default.resolve(paths.root, '.eslintrc.json');
                        // eslint-disable-next-line no-console
                        console.log('Create .eslintrc.json...');
                        fs_1.default.writeFileSync(eslintConfigPath, JSON.stringify(baseEslintConfig, null, 2));
                        // TODO: check if packages declared in eslint config
                        // is not installed to node_modules - ask user to install it
                        // if user will decline it, disable eslint to prevent build crash
                        // TODO: if option `regenerateIfNotEqual` is true
                        // check eslint config and regenerate it if something is not equal
                        // useful when some plugins added which adds some eslint settings
                        // and will replace old config with new updated
                    }
                }
                modifications.insertPlugin(new eslint_webpack_plugin_1.default({
                    extensions: jsFileExtensions,
                    formatter: require.resolve('eslint-formatter-pretty'),
                    context: paths.src,
                    cache: true,
                    cwd: paths.root
                }));
            });
        });
    }
};
WebpackEslintPlugin = __decorate([
    core_1.ReadOptions(WebpackEslintPluginOptions_1.WebpackEslintPluginOptions, 'plugin-webpack-eslint')
], WebpackEslintPlugin);
exports.WebpackEslintPlugin = WebpackEslintPlugin;
//# sourceMappingURL=WebpackEslintPlugin.js.map