"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBaseEslintConfig = void 0;
const path_1 = __importDefault(require("path"));
function getBaseEslintConfig(configOptions, baseConfig) {
    const overrides = (baseConfig === null || baseConfig === void 0 ? void 0 : baseConfig.overrides) || [];
    if (configOptions === null || configOptions === void 0 ? void 0 : configOptions.useTypescript) {
        overrides.unshift({
            files: ['*.ts', '*.tsx'],
            parser: '@typescript-eslint/parser',
            plugins: ['@typescript-eslint'],
            rules: {
                'no-undef': 'off',
                'no-unused-vars': 'off',
                'no-restricted-globals': 'off',
                'no-use-before-define': 'off',
                '@typescript-eslint/no-unused-vars': [
                    'warn',
                    {
                        vars: 'all',
                        args: 'after-used',
                        ignoreRestSiblings: false
                    }
                ]
            }
        });
    }
    return Object.assign(Object.assign({}, baseConfig), { parser: baseConfig.parser || '@babel/eslint-parser', extends: ['eslint:recommended', ...(baseConfig.extends || [])], plugins: ['import', ...(baseConfig.plugins || [])], parserOptions: Object.assign({ ecmaVersion: 2020, sourceType: 'module', babelOptions: {
                configFile: path_1.default.resolve(configOptions.paths.root, 'babel.config.json')
            } }, (baseConfig.parserOptions || {})), env: Object.assign({ browser: true, node: true }, (baseConfig.env || {})), rules: Object.assign({ 'no-unused-vars': 'warn', 'no-console': 'warn' }, (baseConfig.rules || {})), overrides });
}
exports.getBaseEslintConfig = getBaseEslintConfig;
//# sourceMappingURL=getBaseEslintConfig.js.map