"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEslintConfigPath = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
function getEslintConfigPath(rootPath) {
    const basePath = path_1.default.resolve(rootPath, '.eslintrc');
    const extensions = ['', '.json', '.js', '.yaml'];
    const existsExt = extensions.find(ext => {
        const path = basePath + ext;
        return fs_1.default.existsSync(path);
    });
    return existsExt ? basePath + existsExt : null;
}
exports.getEslintConfigPath = getEslintConfigPath;
//# sourceMappingURL=getEslintConfigPath.js.map